package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kstarbound.GlobalDefaults
import ru.dbotthepony.kstarbound.defs.MovementParameters
import ru.dbotthepony.kstarbound.world.World

class EntityMovementController(val entity: DynamicEntity) : AbstractMovementController() {
	override val world: World<*, *> by entity::world
	override var position: Vector2d by entity::position
	override var movementParameters: MovementParameters = GlobalDefaults.movementParameters

	override var isOnGround: Boolean = false
	override var isColliding: Boolean = false
	override var isCollisionStuck: Boolean = false
	override var isCollidingWithNull: Boolean = false
	override var stickingDirection: Double? = null
	override var surfaceSlope: Vector2d = Vector2d.ZERO
	override var surfaceVelocity: Vector2d = Vector2d.ZERO
	override var collisionCorrection: Vector2d = Vector2d.ZERO
	override var liquidPercentage: Double = 0.0
	override var appliedForceRegion: Boolean = false
	override var isZeroGravity: Boolean = false
	override var rotation: Double = 0.0
}
